interface DateFormat {
    /** return: 2024/02/27 20:28:49
         *
        return: 1402/12/08 20:28:49 */
    YYYY_MM_dd_HH_MM_ss: string;
    /** return: 2024/02/27 20:28
         *
        return: 1402/12/08 20:28 */
    YYYY_MM_dd_HH_MM: string;
    /** return: 20:29:59 */
    HH_MM_ss: string;
    /** return: 20:29 */
    HH_MM: string;
    /** return: 2024/02/27
         *
        return: 1402/12/08 */
    YYYY_MM_dd: string;
    /** return: 27 February 2024
         *
        return: 08 اسفند 1402 */
    YYYY_M_dd: string;
    /** return: February 2024
         *
        return: اسفند 1402 */
    YYYY_M: string;
    /** return: Tuesday 27 February 2024
         *
        return: سه‌شنبه 08 اسفند 1402 */
    W_YYYY_M_dd: string;
    /** return: Tuesday 27 February
        *
        return: سه‌شنبه 8 اسفند  */
    W_dd_M: string;
    /** return: 27 February
        *
        return: 8 اسفند  */
    dd_M: string;
    /** return: Year */
    YYYY: string;
    /** return: Month Number two digit */
    MM: string;
    /** return: Month name */
    M: string;
    /** return: day of month */
    d: string;
    /** return: Week name */
    W: string;
    /** return: Weekday number */
    WW: string;
    /** return: Unix */
    Unix: number;
}
declare function format(locale: string, value: string | Date, separator?: string): DateFormat;
declare function convert(locale: string, value: string | Date, separator?: string): DateFormat;
declare function addDays(locale: string, value: string, days: number, separator?: string): DateFormat;
declare function DaysInMonth(locale: string, year: number, month: number): number;
declare function datoToNumber(date: Date | string): number;
declare const sdate: {
    format: typeof format;
    convert: typeof convert;
    addDays: typeof addDays;
    DaysInMonth: typeof DaysInMonth;
    datoToNumber: typeof datoToNumber;
};

export { sdate as default };
