"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var SDate_exports = {};
__export(SDate_exports, {
  default: () => SDate_default
});
module.exports = __toCommonJS(SDate_exports);
function format(locale, value, separator) {
  if (!separator)
    separator = "/";
  const date = new Date(String(value));
  const monthName = new Intl.DateTimeFormat(locale, {
    month: "long"
  }).format(date);
  const fmt = new Intl.DateTimeFormat(locale, {
    weekday: "long",
    day: "numeric",
    month: "numeric",
    year: "numeric",
    hour: "numeric",
    minute: "numeric",
    second: "numeric",
    hour12: false
  }).formatToParts(date).reduce((acc, part) => {
    acc[part.type] = toEnglishNumber(String(part.value));
    return acc;
  }, {});
  fmt.month = fmt.month.toString().padStart(2, "0");
  fmt.day = fmt.day.toString().padStart(2, "0");
  return {
    YYYY_MM_dd_HH_MM_ss: `${fmt.year + separator + fmt.month + separator + fmt.day} ${fmt.hour}:${fmt.minute}:${fmt.second}`,
    YYYY_MM_dd_HH_MM: `${fmt.year + separator + fmt.month + separator + fmt.day} ${fmt.hour}:${fmt.minute}`,
    HH_MM_ss: `${fmt.hour}:${fmt.minute}:${fmt.second}`,
    HH_MM: `${fmt.hour}:${fmt.minute}`,
    YYYY_MM_dd: `${fmt.year + separator + fmt.month + separator + fmt.day}`,
    YYYY_M_dd: ` ${fmt.day} ${monthName} ${fmt.year}`,
    YYYY_M: `${fmt.year} ${monthName}`,
    W_YYYY_M_dd: `${fmt.weekday} ${fmt.day} ${monthName} ${fmt.year}`,
    W_dd_M: `${fmt.weekday} ${fmt.day} ${monthName}`,
    dd_M: `${fmt.day} ${monthName}`,
    YYYY: `${fmt.year}`,
    MM: fmt.month,
    M: monthName,
    d: fmt.day,
    W: `${fmt.weekday}`,
    WW: getWeekdayNumber(fmt.weekday, locale).toString(),
    Unix: Math.floor(new Date(date).getTime() / 1e3)
  };
}
function convert(locale, value, separator) {
  if (locale.toLocaleLowerCase() === "fa") {
    return format("fa", value, separator);
  } else {
    return toGregorian(value, separator);
  }
}
function addDays(locale, value, days, separator) {
  var _a;
  if (locale.toLocaleLowerCase() === "fa") {
    const date = new Date((_a = convert("en", value)) == null ? void 0 : _a.YYYY_MM_dd);
    date.setDate(date.getDate() + days);
    return format("fa", date, separator);
  } else {
    const date = new Date(String(value));
    date.setDate(date.getDate() + days);
    return format("en", date, separator);
  }
}
function DaysInMonth(locale, year, month) {
  var _a, _b;
  if (locale.toLowerCase() === "fa") {
    const date1 = new Date(
      (_a = convert("en", `${year}/${month}/1`)) == null ? void 0 : _a.YYYY_MM_dd
    );
    if (month === 12) {
      year++;
      month = 1;
    } else {
      month++;
    }
    const date2 = new Date(
      (_b = convert("en", `${year}/${month}/1`)) == null ? void 0 : _b.YYYY_MM_dd
    );
    return Math.round(
      (date2.getTime() - date1.getTime()) / (1e3 * 60 * 60 * 24)
    );
  } else {
    const d = new Date(year, month, 0);
    return d.getDate();
  }
}
function datoToNumber(date) {
  return Number(
    toEnglishNumber(String(date).replace(/\//g, "").replace(/-/g, ""))
  );
}
function toEnglishNumber(value) {
  if (value == null)
    return "";
  const englishNumbers = "0123456789";
  const persianNumbers1 = "\u0660\u0661\u0662\u0663\u06F4\u06F5\u06F6\u0667\u0668\u0669";
  const persianNumbers2 = "\u06F0\u06F1\u06F2\u06F3\u06F4\u06F5\u06F6\u06F7\u06F8\u06F9";
  const arabicNumbers = "\u0660\u0661\u0662\u0663\u0664\u0665\u0666\u0667\u0668\u0669";
  let res = "";
  for (const c of value) {
    const index1 = persianNumbers1.indexOf(c);
    const index2 = persianNumbers2.indexOf(c);
    const index3 = arabicNumbers.indexOf(c);
    const index = index1 >= 0 ? index1 : index2 >= 0 ? index2 : index3;
    res += index >= 0 ? englishNumbers[index] : c;
  }
  return res;
}
function toGregorian(value, separator) {
  const JalaliDate = {
    g_days_in_month: [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31],
    j_days_in_month: [31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29]
  };
  if (!separator)
    separator = "/";
  const literal = String(value).indexOf("-") > 0 ? "-" : "/";
  const j_y = +toEnglishNumber(String(value).split(literal)[0]);
  const j_m = +toEnglishNumber(String(value).split(literal)[1]);
  const j_d = +toEnglishNumber(String(value).split(literal)[2]);
  if (value != null) {
    const jy = j_y - 979;
    const jm = j_m - 1;
    const jd = j_d - 1;
    let j_day_no = 365 * jy + Math.floor(jy / 33) * 8 + Math.floor((jy % 33 + 3) / 4);
    for (let i2 = 0; i2 < jm; ++i2) {
      j_day_no += JalaliDate.j_days_in_month[i2];
    }
    j_day_no += jd;
    let g_day_no = j_day_no + 79;
    let gy = 1600 + 400 * Math.floor(
      g_day_no / 146097
    );
    g_day_no = g_day_no % 146097;
    let leap = true;
    if (g_day_no >= 36525) {
      g_day_no--;
      gy += 100 * Math.floor(g_day_no / 36524);
      g_day_no = g_day_no % 36524;
      if (g_day_no >= 365)
        g_day_no++;
      else
        leap = false;
    }
    gy += 4 * Math.floor(g_day_no / 1461);
    g_day_no %= 1461;
    if (g_day_no >= 366) {
      leap = false;
      g_day_no--;
      gy += Math.floor(g_day_no / 365);
      g_day_no = g_day_no % 365;
    }
    let i;
    for (i = 0; g_day_no >= JalaliDate.g_days_in_month[i] + (i === 1 && leap ? 1 : 0); i++) {
      g_day_no -= JalaliDate.g_days_in_month[i] + (i === 1 && leap ? 1 : 0);
    }
    let gm = i + 1;
    let gd = g_day_no + 1;
    gm = gm < 10 ? 0 + gm : gm;
    gd = gd < 10 ? 0 + gd : gd;
    return format(
      "en",
      /* @__PURE__ */ new Date(`${gy + separator + gm + separator + gd}`),
      separator
    );
  } else {
    return format("en", /* @__PURE__ */ new Date(), separator);
  }
}
function getWeekdayNumber(weekdayString, locale) {
  if (locale === "en") {
    return [
      "Saturday",
      "Sunday",
      "Monday",
      "Tuesday",
      "Wednesday",
      "Thursday",
      "Friday"
    ].indexOf(weekdayString);
  } else {
    return [
      "\u0634\u0646\u0628\u0647",
      "\u06CC\u06A9\u0634\u0646\u0628\u0647",
      "\u062F\u0648\u0634\u0646\u0628\u0647",
      "\u0633\u0647\u200C\u0634\u0646\u0628\u0647",
      "\u0686\u0647\u0627\u0631\u0634\u0646\u0628\u0647",
      "\u067E\u0646\u062C\u0634\u0646\u0628\u0647",
      "\u062C\u0645\u0639\u0647"
    ].indexOf(weekdayString);
  }
}
var sdate = {
  format,
  convert,
  addDays,
  DaysInMonth,
  datoToNumber
};
var SDate_default = sdate;
//# sourceMappingURL=index.js.map